#version 330

layout(location = 0) in vec4 position;
layout(location = 2) in vec3 normals;

layout(std140) uniform GlobalMatrices
{
	uniform mat4 perspectiveViewMatrix;
	uniform vec2 windowDimensions;
};

uniform mat4 modelMatrix;
//uniform vec3 vLightPosition;
uniform mat4 viewMatrix;

smooth out vec3 vVaryingNormal;
smooth out vec3 vVaryingLightDir;

void main()
{
	//get surface normal in eye coordinates
	
	//calculating normal matrix
	mat4 MV = modelMatrix;
	mat4 itMV = transpose(inverse(MV));	

	vec4 normal = vec4(0.0, 0.0, 0.0, 0.0);
	normal.xyz = normals.xyz;

	vVaryingNormal = (itMV * normal).xyz;

	//get vertex position in eye coordinates
	vec4 vPosition4 = MV * position;
	vec3 vPosition3 = vPosition4.xyz / vPosition4.w;
	
	//get vector to lightsource
	vec3 vLightPosition = vec3(0.0f, 0.0f, 1.0f);
	vVaryingLightDir = normalize(vLightPosition - vPosition3);
	
	gl_Position = perspectiveViewMatrix * modelMatrix * position;
}
